# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to the versioning of Factorio, so 0.18.x will be at least compatible / tested with Factorio 0.18.x.

## [Released]

## [0.18.5] - 2020-06-08
Added some fancy sound effects and a special [Nilaus](https://www.youtube.com/c/Nilaus) mode.

### Added
- Added sound effects to the calculator whenever a result may be not the desired one (has be enabled in the settings)

### Changed
- Emotes will no longer be displayed at default, "Nilaus mode" has to be enabled for the emotes to appear again

### Fixed
- Recent results weren't properly cleared in 0.18.4

### Misc
- Some code rework, not too fancy stuff

## [0.18.4] - 2020-06-07
### General
Based on user feedback updated the mod

### Added
- Added the possibility to copy the results (from recent and also the current) to the display

### Changed
- Window now remember last location when opened
- Updated the BS button (it's backspace people...) so it now has a nice icon instead of the letters
- Recent results now add to the top, instead of the bottom
- When calculator is opened it focues on the display for entering the equation
- You can click pretty much anywhere now and it focues on the display for entering the equation

### Fixed
- On multiplayer session the window would lag behind while dragging, because the location would be saved on server. This isn't going to happen anymore, hopefully (not tested yet).
- When window is moved out of boundaries, when reopened, it will correct itself to be fully in sight again.
- Settings had weird default values (were set 2 times)

## [0.18.3] - 2020-06-07
### General
A small visual overhaul of the mod
### Added
- Added the possibility to "calculate further" (especially usefull when setting "Clear equation on calculation" is set). When the equation doesn't start with a number, character or parenthesis (so it assumes it starts with a math symbol) it will take the previous result and prepend it to the current equation.

### Changed
- Updated the UI a bit to match it in color a bit more to the Windows calculator
- Updated also the icon on the shortcut to better distinguish it

## [0.18.2] - 2020-06-06
### General
Based on user feedback updated the mod

### Added
- new easter egg :-)
- added more math.lib functions
  - atan2() -> math.atan2()
  - cosh() -> math.cosh()
  - sinh() -> math.sinh()
  - tanh() -> math.tanh()
  - log10() -> math.log10()
  - fmod() -> math.fmod()
  - frexp() -> math.frexp()
  - ldexp() -> math.ldexp()
  - pow() -> math.pow()

### Fixed
- Interpreting ";" as "," in the equation, because of the fix in 0.18.1, so that math functions with more than 1 parameter work. They have to use ";" as a separator for inputs
- Fixed sqrt(-1) equaling "na" because of the rounding fix from 0.18.1. It does now show "NaN" again

## [0.18.1] - 2020-06-06
### General
Based on user feedback updated the mod

### Added
- Shortcut for opening the calculator and automatically focus on the input (Default: Ctrl+Shift+C) 

### Fixed
- Rounding removed 0 at the end, will now stand as it should. So 2.0000001 -> 2.00
- Interpreting "," as "." in the equation, because of some European countries do have a weird keyboard layout

## [0.18.0] - 2020-06-06
### General
- Initial Release of the mod 
- Compatible with Factorio >0.18.0; tested on 0.18.30
- Based on the 4-Function Calculator found in the [Max Rate Calculator](https://mods.factorio.com/mod/MaxRateCalculator) mod by [Theanderblast](https://mods.factorio.com/user/theanderblast)

### Added
- History of recent calculations
- Possibility to copy recent calculations to the current one (with shift+left-click)
- Substitutes some functions & "constants" of the Lua [math-lib](http://lua-users.org/wiki/MathLibraryTutorial)
  - abs() -> math.abs()
  - acos() -> math.acos()
  - asin() -> math.asin()
  - atan() -> math.atan()
  - ceil() -> math.ceil()
  - floor() -> math.floor()
  - cos() -> math.cos()
  - sin() -> math.sin()
  - tan() -> math.tan()
  - deg() -> math.deg()
  - rad() -> math.rad()
  - exp() -> math.exp()
  - log() -> math.log()
  - min() -> math.min()
  - max() -> math.max()
  - modf() -> math.modf()
  - sqrt() -> math.sqrt()
  - huge -> math.huge
  - pi -> math.pi
- Allows the use of "%" (percent sign) in the calculation
- A little easter egg :-)
- Setting for number of decimal places in result (Default: 2). Exact value will be displayed in the tooltip
- Setting if triggering the calculation should clear the current equation (Default: no)

### Changed
- Made the buttons slightly bigger, so that it's better readable on streams.
- Allows to make "complex" calculations with parentheses
- Allows pretty much all characters in the equation field
  - but the "=" (equal sign) will trigger the calculation

### Removed
- Got rid of the memory functions - but introduced the list of recent calculations instead